#
# spec file for package nginx-1.2
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#
%define modsec_name	modsecurity-apache
%define modsec_version	2.7.7
%define	modsec		%{modsec_name}_%{modsec_version}

%define ajp_name	yaoweibin-nginx_ajp_module
%define ajp_version	v0.2.5-19
%define ajp_verhash	df34c09
%define ajp		%{ajp_name}-%{ajp_version}-g%{ajp_verhash}
%define ajp_nover	%{ajp_name}-%{ajp_verhash}
%define with_ajp 1

%define	upstream_fair		gnosek-nginx-upstream-fair
%define	upstream_fair_hash	a18b409
%define	with_upstream_fair	1

%define traffic_rate		bigplum-Nginx-limit-traffic-rate-module
%define traffic_rate_hash	c0c90f5
%define with_traffic_rate	1

%define	dav_ext			arut-nginx-dav-ext-module
%define	dav_ext_version		v0.0.2-2
%define	dav_ext_hash		54cebc1
%define	dav			%{dav_ext}-%{dav_ext_version}-g%{dav_ext_hash}
%define dav_nover		%{dav_ext}-%{dav_ext_hash}
%define	with_dav_ext		0

%define	rtmp_ext		nginx-rtmp-module
%define	rtmp_ext_version	1.0.8
%define rtmp			%{rtmp_ext}-%{rtmp_ext_version}
%define	rtmp_nover		%{rtmp_ext}
%define	with_rtmp_ext		1

Name:           nginx-1.2
Version:        1.2.9
Release:        15.5
#
%define pkg_name nginx
#
%define ngx_prefix     %{_prefix}
%define ngx_sbindir    %{_sbindir}/nginx
%define ngx_conf_dir   %{_sysconfdir}/nginx
%define ngx_conf_path  %{ngx_conf_dir}/nginx.conf
%define ngx_log_dir    /var/log/nginx
%define ngx_error_log  %{ngx_log_dir}/error.log
%define ngx_access_log %{ngx_log_dir}/access.log
%define ngx_pid_path   /var/run/nginx.pid
%define ngx_lock_path  /var/run/nginx.lock
%define ngx_home       /var/lib/nginx
%define ngx_tmp_http   %{ngx_home}/tmp/
%define ngx_tmp_proxy  %{ngx_home}/proxy/
%define ngx_tmp_fcgi   %{ngx_home}/fastcgi/
%define ngx_tmp_scgi   %{ngx_home}/scgi/
%define ngx_tmp_uwsgi  %{ngx_home}/uwsgi/
%define ngx_user_group nginx
%define with_cpp_test   0
%define with_google_perftools 0
%if 0%{?suse_version} >= 1110 && 0%{?sles_version} != 10
%define with_passenger 0
%define with_libatomic 1
%endif
%if 0%{?sles_version} == 10
%define with_modsec 0
%else
%define with_modsec 1
%endif

#
Group:          Productivity/Networking/Web/Proxy
License:        BSD-2-Clause
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?with_cpp_test}
BuildRequires:  gcc-c++
%endif
BuildRequires:  gd-devel
BuildRequires:  GeoIP-devel
%if 0%{?with_google_perftools}
BuildRequires:  google-perftools-devel
%endif
%if 0%{?with_libatomic}
BuildRequires:  libatomic-ops-devel
%endif
BuildRequires:  libxslt-devel
BuildRequires:  openssl-devel
BuildRequires:  pcre-devel
BuildRequires:  pkgconfig
BuildRequires:  zlib-devel
%if 0%{?with_passenger}
BuildRequires:	ruby
BuildRequires:	ruby-devel
BuildRequires:  rubygem-passenger-devel-static
# workaround for obs scheduler:
%if 0%{?suse_version} >= 1210
BuildRequires:  rubygem-rack-1_1
%endif
Recommends:     packageand(rubygem-passenger:rubygem-passenger-nginx)
%endif
%if 0%{?suse_version} >= 1210
BuildRequires:  systemd
%{?systemd_requires}
%define has_systemd 1
%endif
Recommends:     logrotate
%if 0%{?with_modsec}
BuildRequires:	libapr-util1-devel libapr1-devel apache2-devel apache2-prefork openldap2-devel
BuildRequires:	libxml2-devel libtool curl-devel
BuildRequires:	curl
%endif
PreReq:         %fillup_prereq
PreReq:         %insserv_prereq
PreReq:         pwdutils
Provides:       nginx = %{version}-%{release}
#
Conflicts:      nginx-0.5 nginx-0.6 nginx-0.7 nginx-0.8 nginx-0.9 nginx-1.0 nginx-1.1
%requires_eq    perl
#
Url:            http://nginx.org/
Source:         http://nginx.org/download/nginx-%{version}.tar.bz2
Source1:        nginx.init
Source2:	nginx.logrotate
Source3:	%{modsec}.tar.bz2
Source4:	%{ajp}.tar.bz2
Source5:	%{upstream_fair}-%{upstream_fair_hash}.tar.bz2
Source6:	%{traffic_rate}-%{traffic_rate_hash}.tar.bz2
Source7:	%{dav}.tar.bz2
Source8:	%{rtmp}.tar.bz2
Source20:	nginx.service

# PATCH-FIX-UPSTREAM nginx-0.4.0-no_Werror.patch
Patch:          nginx-0.4.0-no_Werror.patch
# PATCH-FIX-UPSTREAM nginx-0.6.38-html.patch
Patch2:         nginx-1.0.12-html.patch
# PATCH-FIX-UPSTREAM nginx-0.4.0-perl_vendor_install.patch
Patch3:         nginx-1.2.4-perl_vendor_install.patch
# PATCH-FIX-UPSTREAM nginx-1.0.4_default_config.patch
Patch4:         nginx-1.0.4_default_config.patch
#

# modsec config patch
#Patch5:		modsecurity-apache_2.7.4_config.patch

Patch100:	CVE-2013-4547.patch

Summary:        A HTTP server and IMAP/POP3 proxy server
%description
nginx [engine x] is a HTTP server and IMAP/POP3 proxy server written by Igor Sysoev.
It has been running on many heavily loaded Russian sites for more than two years.

Author:
-------
    Igor Sysoev

%prep
%setup -n %{pkg_name}-%{version} -a 3 -a 4 -a 5 -a 6 -a 7 -a 8
%patch
%patch3
%patch4
%patch2
%if 0%{?with_ajp}
%__patch -p1 < %{ajp_nover}/ajp.patch
%endif
# % if 0%{?with_modsec}
# cd %{modsec}
# % patch5 -p1
# cd ..
# % endif
%patch100

perl -pi -e 's|\r\n|\n|g' contrib/geo2nginx.pl

%build
%if 0%{?with_modsec}
cd %{modsec}
./autogen.sh
./configure --enable-standalone-module
%__make
cd ..
%endif
%if 0%{?with_passenger}
#ln -s %{_libdir}/ruby/gems/%{rb_ver}/gems/passenger-* passenger
cp -r %{_libdir}/ruby/gems/%{rb_ver}/gems/passenger-* passenger
%endif
./configure                                    \
  --prefix=%{ngx_prefix}/                      \
  --sbin-path=%{ngx_sbindir}                   \
  --conf-path=%{ngx_conf_path}                 \
  --error-log-path=%{ngx_error_log}            \
  --http-log-path=%{ngx_access_log}            \
  --pid-path=%{ngx_pid_path}                   \
  --lock-path=%{ngx_lock_path}                 \
  --http-client-body-temp-path=%{ngx_tmp_http} \
  --http-proxy-temp-path=%{ngx_tmp_proxy}      \
  --http-fastcgi-temp-path=%{ngx_tmp_fcgi}     \
  --http-uwsgi-temp-path=%{ngx_tmp_uwsgi}      \
  --http-scgi-temp-path=%{ngx_tmp_scgi}        \
  --user=nginx --group=nginx                   \
  --with-rtsig_module                          \
  --with-select_module                         \
  --with-poll_module                           \
  --with-ipv6                                  \
%if  0%{?suse_version} > 1110
  --with-file-aio                              \
%endif
  --with-http_ssl_module                       \
  --with-http_realip_module                    \
  --with-http_addition_module                  \
  --with-http_xslt_module                      \
  --with-http_image_filter_module              \
  --with-http_geoip_module                     \
  --with-http_sub_module                       \
  --with-http_dav_module                       \
  --with-http_flv_module                       \
  --with-http_mp4_module                       \
  --with-http_gzip_static_module               \
  --with-http_random_index_module              \
  --with-http_secure_link_module               \
  --with-http_degradation_module               \
  --with-http_stub_status_module               \
  --with-http_perl_module                      \
  --with-perl=%{_bindir}/perl                  \
  --with-mail                                  \
  --with-mail_ssl_module                       \
  --with-pcre                                  \
  %if 0%{?with_libatomic}
  --with-libatomic                             \
  %endif
  %if 0%{?with_passenger}
  --add-module=passenger/ext/nginx             \
  %endif
  %if 0%{?with_modsec}
  --add-module=%{modsec}/nginx/modsecurity	\
  %endif
  %if 0%{?with_ajp}
  --add-module=%{ajp_nover}			\
  %endif
  %if 0%{?with_upstream_fair}
  --add-module=%{upstream_fair}-%{upstream_fair_hash}	\
  %endif
  %if 0%{?with_traffic_rate}
  --add-module=%{traffic_rate}-%{traffic_rate_hash}	\
  %endif
  %if 0%{?with_dav_ext}
  --add-module=%{dav_nover}			\
  %endif
  %if 0%{?with_rtmp_ext}
  --add-module=%{rtmp}				\
  %endif
  %if 0%{?with_google_perftools}
  --with-google_perftools_module               \
  %endif
  %if 0%{?with_cpp_test}
  --with-cpp_test_module                       \
  %endif
  --with-md5=/usr                              \
  --with-sha1=/usr                             \
%if 0%{?suse_version} > 1000 || 0%{?fedora_version} > 4 || 0%{?mandriva_version} > 2006
  --with-cc-opt="%{optflags} -fstack-protector"
%else
  --with-cc-opt="%{optflags}"
%endif
%{__make}

%install
%makeinstall
%perl_process_packlist
#
%{__install} -d -m 0750 %{buildroot}%{ngx_home}/{,tmp,proxy,fastcgi,scgi,uwsgi}
#
%{__install} -D -m 0755 %{S:1} %{buildroot}%{_sysconfdir}/init.d/%{pkg_name}
%{__install} -D -m 0644 %{S:2} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%if 0%{?has_systemd}
%{__install} -D -m 0644 %{S:20} %{buildroot}%{_unitdir}/nginx.service
%endif
%{__ln_s} -f %{_sysconfdir}/init.d/%{pkg_name} %{buildroot}%{_sbindir}/rc%{pkg_name}
%{__rm} %{buildroot}/srv/www/htdocs/index.html

%post
%fillup_and_insserv %{pkg_name}

%if 0%{?has_systemd}
%service_add_post nginx.service
%endif

%preun
%stop_on_removal %{pkg_name}

%if 0%{?has_systemd}
%service_del_preun nginx.service
%endif

%postun
%restart_on_update %{pkg_name}
%{insserv_cleanup}

%if 0%{?has_systemd}
%service_del_postun nginx.service
%endif

%clean
%{__rm} -rf %{buildroot}

%pre
/usr/sbin/groupadd -r %{ngx_user_group} &>/dev/null ||:
/usr/sbin/useradd -g %{ngx_user_group} -s /bin/false -r -c "user for %{ngx_user_group}" -d %{ngx_home} %{ngx_user_group} &>/dev/null ||:

%if 0%{?has_systemd}
%service_add_pre nginx.service
%endif

%files
%defattr(-,root,root,-)
%dir %{ngx_conf_dir}/
%config(noreplace) %{ngx_conf_dir}/koi-utf
%config(noreplace) %{ngx_conf_dir}/koi-win
%config(noreplace) %{ngx_conf_dir}/fastcgi_params
%config(noreplace) %{ngx_conf_dir}/fastcgi_params.default
%config(noreplace) %{ngx_conf_dir}/mime.types
%config(noreplace) %{ngx_conf_dir}/mime.types.default
%config(noreplace) %{ngx_conf_dir}/nginx.conf
%config(noreplace) %{ngx_conf_dir}/nginx.conf.default
%config(noreplace) %{ngx_conf_dir}/fastcgi.conf
%config(noreplace) %{ngx_conf_dir}/fastcgi.conf.default
%config(noreplace) %{ngx_conf_dir}/win-utf
%config(noreplace) %{ngx_conf_dir}/scgi_params
%config(noreplace) %{ngx_conf_dir}/scgi_params.default
%config(noreplace) %{ngx_conf_dir}/uwsgi_params
%config(noreplace) %{ngx_conf_dir}/uwsgi_params.default
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{perl_vendorarch}/auto/nginx/
%{perl_vendorarch}/nginx.pm
%{ngx_sbindir}
%{_mandir}/man3/nginx.3pm*
/srv/www/htdocs/50x.html
%if 0%{?suse_version} && 0%{?suse_version} < 1140
%{_localstatedir}/adm/perl-modules/%{name}
%endif
%{_sysconfdir}/init.d/%{pkg_name}
%{_sbindir}/rc%{pkg_name}
%dir %attr(750,%{ngx_user_group},%{ngx_user_group}) /var/log/nginx/
%dir %attr(750,%{ngx_user_group},%{ngx_user_group}) %{ngx_home}/
%dir %attr(750,%{ngx_user_group},%{ngx_user_group}) %{ngx_tmp_http}
%dir %attr(750,%{ngx_user_group},%{ngx_user_group}) %{ngx_tmp_proxy}
%dir %attr(750,%{ngx_user_group},%{ngx_user_group}) %{ngx_tmp_fcgi}
%dir %attr(750,%{ngx_user_group},%{ngx_user_group}) %{ngx_tmp_scgi}
%dir %attr(750,%{ngx_user_group},%{ngx_user_group}) %{ngx_tmp_uwsgi}
%doc CHANGES* LICENSE README
%doc conf/ contrib/
%if 0%{?has_systemd}
%{_unitdir}/nginx.service
%endif

%changelog
* Sat Dec 21 2013 cs@linux-administrator.com
- update mod_security to release 2.7.7
- update rtmp module to 1.0.8
* Wed Nov 20 2013 cs@linux-administrator.com
- added CVE-2013-4547.patch
- update rtmp module to 1.0.6
* Sun Aug  4 2013 cs@linux-administrator.com
- update rtmp module to 1.0.2
* Tue Jul 30 2013 cs@linux-administrator.com
- update modsecurity to 2.7.5
* Sat Jun 29 2013 cs@linux-administrator.com
- update rtmp module to 1.0.1
* Mon May 27 2013 cs@linux-administrator.com
- update modsecurity to 2.7.4
* Sat May 25 2013 cs@linux-administrator.com
- update rtmp module to 0.9.20
* Mon May 13 2013 cs@linux-administrator.com
- upstream update to 1.2.9
  * Security: contents of worker process memory might be sent to a client
    if HTTP backend returned specially crafted response (CVE-2013-2070);
    the bug had appeared in 1.1.4.
- update rtmp module to 0.9.19
* Fri Apr 26 2013 cs@linux-administrator.com
- update rtmp module to 0.9.18
* Sun Apr 14 2013 cs@linux-administrator.com
- update rtmp module to 0.9.14
* Tue Apr  2 2013 cs@linux-administrator.com
- upstream update to 1.2.8
  * Bugfix: new sessions were not always stored if the "ssl_session_cache
    shared" directive was used and there was no free space in shared
    memory.
  * Bugfix: responses might hang if subrequests were used and a DNS error
    happened during subrequest processing.
  * Bugfix: in the ngx_http_mp4_module.
  * Bugfix: in backend usage accounting.
* Fri Mar 29 2013 cs@linux-administrator.com
- update modsecurity to 2.7.3
* Fri Mar 29 2013 cs@linux-administrator.com
- update rtmp module to 0.9.13
* Mon Mar  4 2013 cs@linux-administrator.com
- update rtmp module to 0.9.11
* Thu Feb 28 2013 cs@linux-administrator.com
- update rtmp module to 0.9.8
* Tue Feb 12 2013 cs@linux-administrator.com
- upstream update to 1.2.7
  * Change: now if the "include" directive with mask is used on Unix
    systems, included files are sorted in alphabetical order.
  * Change: the "add_header" directive adds headers to 201 responses.
  * Feature: the "geo" directive now supports IPv6 addresses in CIDR
    notation.
  * Feature: the "flush" and "gzip" parameters of the "access_log"
    directive.
  * Feature: variables support in the "auth_basic" directive.
  * Feature: the $pipe, $request_length, $time_iso8601, and $time_local
    variables can now be used not only in the "log_format" directive.
  * Feature: IPv6 support in the ngx_http_geoip_module.
  * Bugfix: nginx could not be built with the ngx_http_perl_module in
    some cases.
  * Bugfix: a segmentation fault might occur in a worker process if the
    ngx_http_xslt_module was used.
  * Bugfix: nginx could not be built on MacOSX in some cases.
  * Bugfix: the "limit_rate" directive with high rates might result in
    truncated responses on 32-bit platforms.
  * Bugfix: a segmentation fault might occur in a worker process if the
    "if" directive was used.
  * Bugfix: a "100 Continue" response was issued with "413 Request Entity
    Too Large" responses.
  * Bugfix: the "image_filter", "image_filter_jpeg_quality" and
    "image_filter_sharpen" directives might be inherited incorrectly.
  * Bugfix: "crypt_r() failed" errors might appear if the "auth_basic"
    directive was used on Linux.
  * Bugfix: in backup servers handling.
  * Bugfix: proxied HEAD requests might return incorrect response if the
    "gzip" directive was used.
  * Bugfix: a segmentation fault occurred on start or during
    reconfiguration if the "keepalive" directive was specified more than
    once in a single upstream block.
  * Bugfix: in the "proxy_method" directive.
  * Bugfix: a segmentation fault might occur in a worker process if
    resolver was used with the poll method.
  * Bugfix: nginx might hog CPU during SSL handshake with a backend if
    the select, poll, or /dev/poll methods were used.
  * Bugfix: the "[crit] SSL_write() failed (SSL:)" error.
  * Bugfix: in the "fastcgi_keep_conn" directive.
  - update rtmp module to 0.9.7
* Fri Jan 25 2013 cs@linux-administrator.com
- update modsecurity to 2.7.2
* Fri Jan 25 2013 cs@linux-administrator.com
- update rtmp module to 0.9.1
* Wed Jan 16 2013 cs@linux-administrator.com
- update rtmp module to 0.9.0
* Sat Jan 12 2013 cs@linux-administrator.com
- added rtmp module 0.8.7
* Tue Dec 11 2012 cs@linux-administrator.com
- upstream update to 1.2.6
  * Feature: the $request_time and $msec variables can now be used not
    only in the "log_format" directive.
  * Bugfix: cache manager and cache loader processes might not be able to
    start if more than 512 listen sockets were used.
  * Bugfix: in the ngx_http_dav_module.
* Thu Nov 15 2012 cs@linux-administrator.com
- disable modsecurity build (segfaults)
  segfault at 8 ip 000000000056bb39 sp 00007fffe10d6550 error 4 in nginx[400000+1d8000]
* Thu Nov 15 2012 cs@linux-administrator.com
- update modsecurity to 2.7.1
* Tue Nov 13 2012 cs@linux-administrator.com
- upstream update to 1.2.5
  * Feature: the "optional_no_ca" parameter of the "ssl_verify_client"
    directive.
  * Feature: the $bytes_sent, $connection, and $connection_requests
    variables can now be used not only in the "log_format" directive.
  * Feature: resolver now randomly rotates addresses returned from cache.
  * Feature: the "auto" parameter of the "worker_processes" directive.
  * Bugfix: "cache file ... has md5 collision" alert.
  * Bugfix: OpenSSL 0.9.7 compatibility.
* Sat Oct 20 2012 cs@linux-administrator.com
- update modsecurity to 2.7.0
  * http://www.modsecurity.org/projects/modsecurity/nginx/index.html
* Sun Oct  7 2012 cs@linux-administrator.com
- added dav_ext_module
  * https://github.com/arut/nginx-dav-ext-module
* Sun Oct  7 2012 cs@linux-administrator.com
- upstream update to 1.2.4
  * Bugfix: in the "limit_req" directive; the bug had appeared in 1.1.14.
  * Bugfix: nginx could not be built by gcc 4.7 with -O2 optimization if
    the --with-ipv6 option was used.
  * Bugfix: a segmentation fault might occur in a worker process if the
    "map" directive was used with variables as values.
  * Bugfix: a segmentation fault might occur in a worker process if the
    "geo" directive was used with the "ranges" parameter but without the
    "default" parameter; the bug had appeared in 0.8.43.
  * Bugfix: in the -p command-line parameter handling.
  * Bugfix: in the mail proxy server.
  * Bugfix: of minor potential bugs.
  * Bugfix: nginx/Windows could not be built with Visual Studio 2005 Express.
- added limit_traffic_rate_module
  * https://github.com/bigplum/Nginx-limit-traffic-rate-module
- added upstream_fair_module
  * http://wiki.nginx.org/HttpUpstreamFairModule
* Mon Oct  1 2012 cs@linux-administrator.com
- added nginx_ajp_module
  * https://github.com/yaoweibin/nginx_ajp_module
* Mon Sep 24 2012 cs@linux-administrator.com
- added modsecurity-ngx_http_preaccess_phase.patch
* Mon Sep 24 2012 cs@linux-administrator.com
- refresh perl_vendor_install patch
* Mon Sep 24 2012 cs@linux-administrator.com
- upstream update 1.2.3
  * Feature: the Clang compiler support.
  * Bugfix: extra listening sockets might be created.
  * Bugfix: nginx/Windows might hog CPU if a worker process failed to start.
  * Bugfix: the "proxy_pass_header", "fastcgi_pass_header",
    "scgi_pass_header", "uwsgi_pass_header", "proxy_hide_header",
    "fastcgi_hide_header", "scgi_hide_header", and "uwsgi_hide_header"
    directives might be inherited incorrectly.
  * Bugfix: trailing dot in a source value was not ignored if the "map"
    directive was used with the "hostnames" parameter.
  * Bugfix: incorrect location might be used to process a request if a
    URI was changed via a "rewrite" directive before an internal redirect
    to a named location.
- update modesecurity to 2.7rc3
  * http://www.modsecurity.org/projects/modsecurity/nginx/index.html
* Sun Jul 29 2012 cs@linux-administrator.com
- build with modsecurity 2.7rc2
  * http://www.modsecurity.org/projects/modsecurity/nginx/index.html
* Thu Jul  5 2012 cs@linux-administrator.com
- upstream update 1.2.2
  * Change: the "single" parameter of the "keepalive" directive is now
    ignored.
  * Change: SSL compression is now disabled when using all versions of
    OpenSSL, including ones prior to 1.0.0.
  * Feature: the "proxy_pass", "fastcgi_pass", "scgi_pass", "uwsgi_pass"
    directives, and the "server" directive inside the "upstream" block,
    now support IPv6 addresses.
  * Feature: the "resolver" directive now support IPv6 addresses and an
    optional port specification.
  * Feature: the "least_conn" directive inside the "upstream" block.
  * Feature: it is now possible to specify a weight for servers while
    using the "ip_hash" directive.
  * Feature: it is now possible to use the "ip_hash" directive to balance
    IPv6 clients.
  * Feature: the $status variable can now be used not only in the
    "log_format" directive.
  * Bugfix: nginx could not be built with ngx_cpp_test_module; the bug
    had appeared in 1.1.12.
  * Bugfix: access to variables from SSI and embedded perl module might
    not work after reconfiguration.
  * Bugfix: in the ngx_http_xslt_filter_module.
  * Bugfix: memory leak if $geoip_org variable was used.
  * Bugfix: in the "proxy_cookie_domain" and "proxy_cookie_path"
    directives.
  * Bugfix: a segmentation fault might occur in a worker process on
    shutdown if the "resolver" directive was used.
  * Bugfix: a segmentation fault might occur in a worker process if the
    ngx_http_mp4_module was used.
  * Bugfix: in the ngx_http_mp4_module.
  * Bugfix: a segmentation fault might occur in a worker process if
    conflicting wildcard server names were used.
  * Bugfix: nginx might be terminated abnormally on a SIGBUS signal on
    ARM platform.
  * Bugfix: an alert "sendmsg() failed (9: Bad file number)" on HP-UX
    while reconfiguration.
* Sun Jun 17 2012 cs@linux-administrator.com
- upstream update 1.2.1
  * Security: now nginx/Windows ignores trailing dot in URI path
    component, and does not allow URIs with ":$" in it.
  * Feature: the "debug_connection" directive now supports IPv6 addresses
    and the "unix:" parameter.
  * Feature: the "set_real_ip_from" directive and the "proxy" parameter
    of the "geo" directive now support IPv6 addresses.
  * Feature: the "real_ip_recursive", "geoip_proxy", and
    "geoip_proxy_recursive" directives.
  * Feature: the "proxy_recursive" parameter of the "geo" directive.
  * Bugfix: a segmentation fault might occur in a worker process if the
    "resolver" directive was used.
  * Bugfix: a segmentation fault might occur in a worker process if the
    "fastcgi_pass", "scgi_pass", or "uwsgi_pass" directives were used and
    backend returned incorrect response.
  * Bugfix: a segmentation fault might occur in a worker process if the
    "rewrite" directive was used and new request arguments in a
    replacement used variables.
  * Bugfix: nginx might hog CPU if the open file resource limit was reached.
  * Bugfix: nginx might loop infinitely over backends if the
    "proxy_next_upstream" directive with the "http_404" parameter was
    used and there were backup servers specified in an upstream block.
  * Bugfix: adding the "down" parameter of the "server" directive might
    cause unneeded client redistribution among backend servers if the
    "ip_hash" directive was used.
  * Bugfix: socket leak.
  * Bugfix: in the ngx_http_fastcgi_module.
* Sun May  6 2012 cs@linux-administrator.com
- upstream update 1.2.0
  * Bugfix: a segmentation fault might occur in a worker process if the
    "try_files" directive was used; the bug had appeared in 1.1.19.
  * Bugfix: response might be truncated if there were more than IOV_MAX
    buffers used.
  * Bugfix: in the "crop" parameter of the "image_filter" directive.
